package com.unis.hlht.server.mapper.tablecommentmap;

import com.unis.hlht.server.po.table.TableCommentPO;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;

/**
 * @description:表和表说明数据访问对象
 * @author:马伟栋
 * @version:v1.0
 * @create:2019/05/12-12:29
 **/
@SuppressWarnings("all")
@Repository
public interface TableCommentMapper {

    @Select("select * from TABLE_COMMENT_MAP where TABLE_NAME = #{tableName}")
    TableCommentPO selectByTableName(@Param("tableName") String tableName);

}
