package com.unis.hlht.server.po.table;

import lombok.Data;

import javax.persistence.Table;
import java.util.Date;

/**
 * @description:数据上传记录实体类
 * @author:马伟栋
 * @version:v1.0
 * @create:2019/07/09-11:09
 **/
@Data
@Table(name = "UPLOAD_MEMO")
@SuppressWarnings("all")
public class DataUploadMemoPO {

    //id
    private String id;

    //接口
    private String api;

    //接口名称
    private String apiName;

    //解析数据指令后得知需要上传的数据总量
    private Integer totalUploadSize;

    //上传次数计录
    private Integer uploadCount;

    //此次上传的数据总量（每一百条上传一次）
    private Integer currentUploadSize;

    //上传结果
    private String uploadResultCode;

    //上传结果
    private String uploadResult;

    //上传时间
    private Date uploadTime;

}
