package com.unis.hlht.server.server.instruction;
//package com.unis.hlht.server.server.instruction;
//
//
//import com.alibaba.fastjson.JSONObject;
//import com.alibaba.fastjson.serializer.SerializerFeature;
//import com.unis.hlht.server.common.UploadResponse;
//import com.unis.hlht.server.common.restconfig.RestNational;
//import com.unis.hlht.server.dto.instruction.DataParas;
//import com.unis.hlht.server.dto.instruction.InstructionParasDTO;
//import com.unis.hlht.server.dto.instruction.UpLoadDTO;
//import com.unis.hlht.server.po.table.DataUploadMemoPO;
//import com.unis.hlht.server.server.apimappingtable.ApiMappingTableServer;
//import com.unis.hlht.server.server.tabledata.TableDataServer;
//import com.unis.hlht.server.server.uploadmemo.DataUploadMemoServer;
//import com.unis.hlht.server.utils.*;
//import lombok.extern.slf4j.Slf4j;
//import org.apache.commons.lang3.StringUtils;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.beans.factory.annotation.Value;
//import org.springframework.stereotype.Service;
//import java.util.ArrayList;
//import java.util.List;
//import java.util.Map;
//import java.util.Set//
///**
// * @description:指令受控服务
// * @author:马伟栋
// * @version:v1.0
// * @create:2019/02/19-13:43
// **/
//@Slf4j
//@Service
//@SuppressWarnings("all")
//public class InstructionServer2 {
//
//    @Value("${uid}")
//    private String uid;
//
//    @Value("${localprikey}")
//    private String localPrivateKey;
//
//    @Value("${nationalpubkey}")
//    private String nationalPublicKey;
//
//    @Autowired
//    private TableDataServer tableDataServer;
//
//    @Autowired
//    private RestNational restNational;
//
//    @Autowired
//    private DataUploadMemoServer dataUploadMemoServer;
//
//    @Autowired
//    private ApiMappingTableServer apiMappingTableServer;
//
//    /**
//     * 心跳指令处理
//     *
//     * @return响应码
//     */
//    public ResponseCode heartBeat() {
//        //记录日志
//        log.info("心跳指令响应成功。");
//        return ResponseCode.success();
//    }
//
//    /**
//     * 数据指令处理
//     *
//     * @return响应码
//     */
//    public synchronized ResponseCode dataUpload(InstructionParasDTO dto) throws Exception {
//        DataParas data = dto.getData();
//        if (data.getContent() != null) {
//            //接口内容
//            String[] contents = data.getContent().split(";");
//            for (String content : contents) {
//                //根据接口查找表名
//                String tableName = apiMappingTableServer.findTableNameByApi(content);
//                if (tableName != null) {
//                    tableName = tableName.trim();
//                }
//                //根据表名和时间查找对应表数据
//                List<Map> tabledata = tableDataServer.findAllByLoadDate(tableName, data.getStarttime(), data.getEndtime());
//                for (Map map : tabledata) {
//                    Set<String> keySet = map.keySet();
//                    for (String key : keySet) {
//                    	Object str = map.get(key);
//                    	if(str == null) {
//                    		map.put(key, "");
//                    	}
//    				}
//				}
//                //每一百条数据上传一次
//                int subLength = 100;
//                if (content.equalsIgnoreCase("1107")) {
//                    //文件信息接口每5条数据上传一次(数据较大)
//                    subLength = 2;
////                    subLength = 5;
//                }
//                int dataSize = tabledata.size();
//                int count = 0;
//                List<Map> tabledataSub = new ArrayList<>();
//                for (int i = 0; i < dataSize; i += subLength) {
//                    if (i + subLength > tabledata.size()) {
//                        tabledataSub = tabledata.subList(i, tabledata.size());
//                    } else {
//                        tabledataSub = tabledata.subList(i, i + subLength);
//                    }
//                    //分离数据id
//                    List<String> ids = tabledataSub.stream().collect(() -> new ArrayList<String>(),
//                            (list, tableDataMap) -> list.add((String) tableDataMap.get("id")),
//                            (list1, list2) -> list1.addAll(list2)
//                    );
//                    //去除数据中id键值对
//                    for (Map<String, String> map : tabledataSub) {
//                        map.entrySet().removeIf(entry -> entry.getKey().equalsIgnoreCase("id"));
//                    }
//                    //数据上传
//                    UploadResponse uploadResponse = uploadData(tabledataSub, dto.getOrderid(), content, dataSize);
//                    String code = uploadResponse.getCode();
//                    String result = uploadResponse.getResult();
//                    if (StringUtils.equalsIgnoreCase(code, "200")) {
//                        //根据表名和数据id更新上传标记为1：已上传
//                        tableDataServer.updateIsUploadToTrueByIds(tableName, ids);
//                    }
//
//                    //数据上传信息记录
//                    String memo = apiMappingTableServer.findMemoByApi(content);
//                    dataUploadMemoServer.save(transTodataUploadPO(content, memo, dataSize, i + 1, tabledataSub.size(), code, result));
//                    log.info("接口:" + content + " 第" + ++count + "次上传数据,此次上传:" + tabledataSub.size() + "条 共:" + dataSize + "条; 上传数据状态:code=" + code + " result=" + result);
//                }
//            }
//        }else {
//        	log.info("国家局下发指令："+ dto.getOrderid());
//        	
//        }
//        log.info("数据指令处理完成，orderId=" + dto.getOrderid());
//
//        return ResponseCode.success();
//    }
//
//    /**
//     * @param api
//     * @param apiName
//     * @param totalUploadSize
//     * @param uploadCount
//     * @param currentUploadSize
//     * @param uploadResultCode
//     * @param uploadResult
//     * @return
//     */
//    private DataUploadMemoPO transTodataUploadPO(String api, String apiName, Integer totalUploadSize, Integer uploadCount, Integer currentUploadSize, String uploadResultCode, String uploadResult) {
//        DataUploadMemoPO po = new DataUploadMemoPO();
//        po.setApi(api);
//        po.setApiName(apiName);
//        po.setTotalUploadSize(totalUploadSize);
//        po.setUploadCount(uploadCount);
//        po.setCurrentUploadSize(currentUploadSize);
//        po.setUploadResultCode(uploadResultCode);
//        po.setUploadResult(uploadResult);
//        return po;
//    }
//
//    /**
//     * 数据上传
//     *
//     * @param tabledata
//     * @param orderid
//     * @throws Exception
//     */
//    private UploadResponse uploadData(List<Map> tabledata, String orderid, String api, Integer dataSize) throws Exception {
//        //数据整合
//        UpLoadDTO dto = dataIntegration(tabledata, orderid, dataSize);
//        //数据上传
//        return restNational.uploadData2National(dto, api);
//    }
//
//    /**
//     * 数据整合
//     *
//     * @param tabledata 表数据
//     * @param orderid   指令ID
//     */
//    private UpLoadDTO dataIntegration(List<Map> tabledata, String orderid, Integer dataSize) throws Exception {
//        //表数据转成json
////        ValueFilter filter = new ValueFilter() {
////            @Override
////            public Object process(Object obj, String s, Object v) {
////                if (v == null) {
////                    return "";
////                }
////                return v;
////            }
////        };
////        String jsonData = JSONObject.toJSONString(tabledata, filter, SerializerFeature.WriteMapNullValue, SerializerFeature.WriteNullStringAsEmpty, SerializerFeature.WriteNullNumberAsZero, SerializerFeature.WriteNullBooleanAsFalse);
//        String jsonData = JSONObject.toJSONString(tabledata, SerializerFeature.WriteMapNullValue, SerializerFeature.WriteNullStringAsEmpty, SerializerFeature.WriteNullNumberAsZero, SerializerFeature.WriteNullBooleanAsFalse);
//        UpLoadDTO dto = new UpLoadDTO();
//        //报文标识ID
//        dto.setId(OrderID.getId());
//        //身份ID
//        dto.setUid(uid);
//        //指令ID
//        dto.setOrderid(orderid);
//        //身份签名
//        dto.setAccess_token(getAccessToken());
//        //指令要求数据总条数
//        dto.setDatalength(dataSize);
//        //数据主体
//        dto.setData(getDataWithEncrypt(jsonData));
//        //数据摘要
//        dto.setDigst(getDigst(jsonData));
//        return dto;
//    }
//
//    /**
//     * 数据加密
//     *
//     * @param tabledata 表数据
//     * @return
//     * @throws Exception
//     */
//    private String getDataWithEncrypt(String tabledata) throws Exception {
//        //对data进行rsa公钥加密
//        return SecureMngr.encryptByPubKey(tabledata, nationalPublicKey);
//    }
//
//
//    /**
//     * 身份签名
//     *
//     * @return
//     */
//    private String getAccessToken() throws Exception {
//        //对身份信息进行本地私钥签名
//        String accessToken = uid + "_" + DateUtil.getNowDateFormat("yyyy-MM-dd");
//        return SecureMngr.sign(accessToken.getBytes("UTF-8"), localPrivateKey);
//    }
//
//    /**
//     * 摘要
//     *
//     * @param tabledata
//     * @return
//     */
//    private String getDigst(String tabledata) {
//        return MD5Utils.MD5(tabledata);
//    }
//
//    /**
//     * 获取表中数据总条数
//     *
//     * @param api
//     * @return
//     */
//    private Integer getDataCount(String api) {
//        return tableDataServer.findDataCount(api);
//    }
//
//}
