package com.unis.hlht.server;

import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cache.annotation.EnableCaching;
import org.springframework.context.annotation.PropertySource;
import org.springframework.scheduling.annotation.EnableScheduling;

@EnableScheduling
@SpringBootApplication
@MapperScan("com.unis.hlht.server.mapper")
@PropertySource("classpath:/secure/secure.yml")
public class SxlsHlhtServerApplication {

    public static void main(String[] args) {
        SpringApplication.run(SxlsHlhtServerApplication.class, args);
        System.out.println("————————————————————————————————————————启动成功————————————————————————————————————————");
    }

}
