package com.unis.hlht.server.dto.datashare;

import com.unis.hlht.server.dto.instruction.DataParas;
import lombok.Data;

/**
 * @description:国家平台向省级平台共享数据请求参数
 * @author:马伟栋
 * @version:v1.0
 * @create:2019/02/19-14:11
 **/
@Data
@SuppressWarnings("all")
public class DataShareParasDTO {

    //用户id:6位行政区划代码
    private String userid;

    //签名：RSA的私钥对行政区划代码和当天日期对进行签名；格式：610000_2018-06-02
    private String access_token;

    //查询数据起始位置
    private String pointer;

}
