package com.unis.hlht.server.dto.instruction;

import lombok.Data;

/**
 * @description:国家平台指令下发参数
 * @author:马伟栋
 * @version:v1.0
 * @create:2019/02/19-14:11
 **/
@Data
@SuppressWarnings("all")
public class InstructionParasDTO {

    //指令ID
    private String orderid;

    //指令类型:0-心跳指令 1-数据指令
    private String type;

    //指令内容
    private DataParas data;

    private String depDwdm;

    //每次上传的数据量
    private Integer everyUploadDateNum;

    //业务数据id
    private String busId;

}
