package com.unis.hlht.server.dto.lylttj;

import java.util.Map;

import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiParam;
import lombok.Data;

/**
 * 粮食流通基础设施建设投资情况数据接口
 * @author 九幽
 *
 */
@Data
public class ProcessTransformDTO {
	private String unitid;

	@ApiModelProperty(value="库点名称")	
	private String dwmc;

	@ApiModelProperty(value="年度/时期")	
	private String datatime;
	
	@ApiModelProperty(value="加工转化企业基本情况")	
	private String jgzhqyjbqk;
	
	@ApiModelProperty(value="产业化龙头企业")	
	private String cyhltqy;
	
	@ApiModelProperty(value="应急加工企业")	
	private String yjjgqy;
	
	@ApiModelProperty(value="放心粮油示范工程")	
	private String fxlysfgc;
	
	@ApiModelProperty(value="主食加工中央厨房")	
	private String zsjgzycf;
	
	@ApiModelProperty(value="研发中心")	
	private String yfzx;
	
	@ApiModelProperty(value="全国工业产品生产许可证（QS）")	
	private String qggycpscxkz;
	
	@ApiModelProperty(value="数量")	
	private Double sl;
}
