package com.unis.hlht.server.server.lylttj;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.unis.hlht.server.dto.lylttj.ProcessTransformDTO;
import com.unis.hlht.server.dto.lylttj.ReserveScaleDto;
import com.unis.hlht.server.mapper.lylttj.ProcessTransformMapper;

/**
 * @description:加工转换信息数据接口
 * @author:马伟栋
 * @version:v1.0
 * @create:2019/07/09-11:23
 **/
@Service
@SuppressWarnings("all")
public class ProcessTransformServer {

	@Autowired
	private ProcessTransformMapper mapper;

	public PageInfo findAll(ProcessTransformDTO dto, int page, int pageSize) {
		PageHelper.startPage(page, pageSize);
		
		if(dto.getDatatime() != null && !("").equals(dto.getDatatime())) {
			dto.setDatatime(dto.getDatatime().substring(0,4));
		}
		List<ProcessTransformDTO> list = mapper.findAll(dto);
		for (ProcessTransformDTO pro : list) {
			StringBuffer sb = new StringBuffer();
			List<ProcessTransformDTO> detailList = mapper.findDetail(pro);
			for (ProcessTransformDTO detailPro : detailList) {
				sb.append(detailPro.getJgzhqyjbqk());
				sb.append("(");
				sb.append(detailPro.getSl());
				sb.append(")");
				sb.append("、");
			}
			pro.setJgzhqyjbqk(sb.toString());
		}
		PageInfo pageInfo = new PageInfo(list);
		return pageInfo;
	}

	
	public static void main(String[] args) {
		String s = "2015N0001";
		System.out.println(s.substring(0, 4) + s.substring(s.length() -2));
	}
//	private void handleKclsxzSb(StringBuffer kclsxzSb, ReserveScaleDto res, List<ReserveScaleDto> dataList) {
//		JSONArray xzArr = new JSONArray();
//		JSONObject xzJsonObj = new JSONObject();
//		for (ReserveScaleDto data : dataList) {
//			//同一单位
//			if(data.getUnitid().equals(res.getUnitid()) && data.getDatatime().equals(res.getDatatime())) {
//				if(xzJsonObj.getJSONObject(data.))
//			}
//		}
//	}
	
}
