package com.unis.hlht.server.utils;

import lombok.Getter;
import lombok.Setter;

/**
 * @description:响应码
 * @author:马伟栋
 * @version:v1.0
 * @create:2019/02/19-13:57
 **/
@Getter
@Setter
public class ResponseCode {

    private static final String SUCCESS_CODE = "200";

    private static final String ERROR_CODE = "500";

    private String code;

    private String result;

    public ResponseCode() {
    }

    public ResponseCode(String code, String result) {
        this.code = code;
        this.result = result;
    }

    public static ResponseCode success() {
        return new ResponseCode("200", "指令解析成功");
    }

    public static ResponseCode error() {
        return new ResponseCode("500", "指令解析失败");
    }

}
